{{define "title"}}
Setup CI project {{.RepoName}}
{{end}}

{{define "content"}}
{{$p := .UrlPrefix}}
{{$repo_id := .RepoID}}
<form id="setup_form" class="was-validated" method="POST">
    <div class="row py-2">
        <div class="form-group col-md-3">
            <label for="repository_id">Repository ID: </label>
            <input type="text" name="repository_id" id="repository_id" value="{{.RepoID}}" class="form-control-plaintext fw-bold" readonly>
        </div>
        <div class="form-group col-md-3">
            <label for="repository_owner">Owner: </label>
            <input type="text" name="repository_owner" id="repository_owner" value="{{.RepoOwner}}" class="form-control-plaintext fw-bold" readonly>
        </div>
        <div class="form-group col-md-6">
            <label for="repo_url">Repository URL:</label>
            <input type="text" name="repo_url" id="repo_url" value="{{.RepoURL}}" class="form-control-plaintext fw-bold" readonly>
        </div>
    </div>
    {{if ne .RepoWebhookSetup "" }}
    <div class="row py-2">
        <div class="form-group col-md-12">
            <button class="btn btn-primary" id="webhook_setup_details_button" type="button" data-bs-toggle="collapse" data-bs-target="#webhook_setup_details" aria-expanded="true" aria-controls="webhook_setup_details">
                Webhook setup details
            </button>
            <div class="collapse show" id="webhook_setup_details">
                <div class="card card-body">
                    <p>Go to <a href="{{.RepoWebhookUrl}}" target="_blank" rel="noopener noreferrer">{{.RepoWebhookUrl}}</a> and add a new webhook</p>
                    <pre><code>{{.RepoWebhookSetup}}</code></pre>
                </div>
            </div>
        </div>
    </div>
    {{end}}
    <div class="accordion" id="accordionConfigs">
        <div class="accordion-item">
            <h2 class="accordion-header" id="headerAdmin">
                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#collapseAdmin" aria-expanded="false" aria-controls="collapseAdmin">
                    <strong>Admin config</strong>
                </button>
            </h2>
            <div id="collapseAdmin" class="accordion-collapse collapse" aria-labelledby="headerAdmin" data-bs-parent="#accordionConfigs">
                <div class="accordion-body">
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="admin_user">Admin permissions (CSCS usernames/groups):</label></summary>
                            <p>People with admin permissions can edit the settings of the CI setup, i.e. they can edit this page. They also have all manager permissions, i.e. there is no need to mention the same user/group in the manager field.</p>
                        </details>
                        <input type="text" name="admin_user" id="admin_user" value="{{.RepoAdmins}}" class="form-control">
                        <small id="AdminUserHelp" class="form-text text-muted">Comma-separated list of admin users/groups.</small>
                    </div>
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="manager_user">Manager permissions (CSCS usernames/groups):</label></summary>
                            <p>People with manager permissions can restart CI jobs, but the cannot edit the CI setup, i.e. they cannot visit this page.</p>
                        </details>
                        <input type="text" name="manager_user" id="manager_user" value="{{.RepoManagers}}" class="form-control">
                        <small id="ManagerUserHelp" class="form-text text-muted">Comma-separated list of manager users/groups.</small>
                    </div>
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="f7t_client_id">Firecrest Consumer Key:</label></summary>
                            <p>Firecrest Consumer Key that will be used to submit jobs on the cluster. Consumer Key/Secret for CSCS can be created at <a href="https://developer.cscs.ch">https://developer.cscs.ch</a>. More details are available at the <a href="https://confluence.cscs.ch/x/FRjJMw">full documentation</a></p>
                        </details>
                        <input type="text" name="f7t_client_id" id="f7t_client_id" value="{{.RepoF7tClientId}}" class="form-control">
                    </div>
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="f7t_client_secret">Firecrest Consumer Secret:</label></summary>
                            <p>Firecrest Consumer Secret that will be used to submit jobs on the cluster. Consumer Key/Secret for CSCS can be created at <a href="https://developer.cscs.ch">https://developer.cscs.ch</a>. More details are available at the <a href="https://confluence.cscs.ch/x/FRjJMw">full documentation</a></p>
                        </details>
                        <input type="text" name="f7t_client_secret" id="f7t_client_secret" value="" class="form-control">
                        <small id="f7tClientSecretHelp" class="form-text text-muted">Current value is not echoed, leave it empty to keep it unchanged.</small>
                    </div>
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="f7t_slurm_account">Firecrest Slurm Account:</label></summary>
                            <p>Jobs will be submitted under this slurm account, i.e. accounting will be billed by default to this account (firecrest client id must be allowed to submit jobs to this slurm account)</p>
                        </details>
                        <input type="text" name="f7t_slurm_account" id="f7t_slurm_account" value="{{.RepoF7tSlurmAccount}}" class="form-control">
                    </div>
                </div>
            </div>
        </div>
        <div class="accordion-item">
            <h2 class="accordion-header" id="headerGlobal">
                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#collapseGlobal" aria-expanded="false" aria-controls="collapseGlobal">
                    <strong>Global config</strong>
                </button>
            </h2>
            <div id="collapseGlobal" class="accordion-collapse collapse" aria-labelledby="headerGlobal" data-bs-parent="#accordionConfigs">
                <div class="accordion-body">
                    <div class="form-group py-2">
                        <label for="name">Repository name:</label>
                        <input type="text" name="name" id="name" value="{{.RepoName}}" class="form-control" required>
                    </div>
                    <div class="form-check py-2">
                        <label class="form-check-label" for="privaterepo" data-bs-toggle="collapse" data-bs-target="#collapsePrivateRepoPublicSshKey"><input type="checkbox" class="form-check-input" value="true" name="privaterepo" id="privaterepo"{{if .IsPrivate}} checked{{end}}> Private repository</label>
                        <small id="privaterepoHelp" class="form-text text-muted">Make the mirror a private repository (this implies that log files cannot be viewed in gitlab directly, there is a simpler interface to view log files)</small>
                        <div class="collapse{{if .IsPrivate}} show{{end}}" id="collapsePrivateRepoPublicSshKey">
                            <div class="card card-body">
                                <p>Your personal SSH deploy key is: <code>{{.SSHKeyPublic}}</code></p>
                                {{if eq .RepoProvider "github" }}
                                <p>Add this deploy key to <a href="{{.RepoURL}}/settings/keys" target="_blank" rel="noopener noreferrer">your repo here</a></p>
                                {{else if eq .RepoProvider "bitbucket" }}
                                <p>Add this deploy key to <a href="{{.RepoURL}}/admin/access-keys/" target="_blank" rel="noopener noreferrer">your repo here</a></p>
                                {{else if eq .RepoProvider "gitlab" }}
                                <p>Add this deploy key to <a href="{{.RepoURL}}/-/settings/repository" target="_blank" rel="noopener noreferrer">your repo here</a> in the section <em>Deploy keys</em></p>
                                {{else}}
                                <p>Unfortunately no documentation how to add your SSH deploy key</p>
                                {{end}}
                                <p><strong>It is required to add this key such that the source code can be cloned on the target machines. It is <em>not</em> necessary to grant write acces to this deploy key.</strong></p>
                                <p>SSH deploy key fingerprint (check fingerprint after adding, they must match): <span class="fst-italic">{{.SSHKeyPublicFingerprint}}</span></p>
                            </div>
                        </div>
                    </div>
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="notification_token">Notification token:</label></summary>
                            {{if eq .RepoProvider "github"}}
                            <p>Github's documentation on personal access tokens can be found at <a href="https://docs.github.com/en/authentication/keeping-your-account-and-data-secure/creating-a-personal-access-token" target="_blank" rel="noopener noreferrer">https://docs.github.com/en/authentication/keeping-your-account-and-data-secure/creating-a-personal-access-token</a>. Following the documentation for <code>Personal access tokens (classic)</code> create a token with scope <code>repo:status</code>. The personal access token is your notification token.<br />As of now fine-grained tokens are not yet supported.</p>
                            {{else if eq .RepoProvider "bitbucket" }}
                            <p>Bitbucket offers three different access tokens: Repository / Project / Workspace. Bitbucket's documentation can be found at <a href="https://developer.atlassian.com/cloud/bitbucket/rest/intro/#access-tokens" target="_blank" rel="noopener noreferrer">https://developer.atlassian.com/cloud/bitbucket/rest/intro/#access-tokens</a>. Following the documentation create an access token with the scope <code>Reposiotry:read</code>.</p>
                            {{else if eq .RepoProvider "gitlab" }}
                            <p>Gitlab allows, depending on your license, to create <a href="https://docs.gitlab.com/ee/user/project/settings/project_access_tokens.html">Project Access tokens</a> or <a href="https://docs.gitlab.com/ee/user/profile/personal_access_tokens.html">Personal Access Tokens</a>. Project access tokens should be preferred, since their scope is tighter. The access token must have at least <code>Developer</code> role and the scope <code>api</code>.</p>
                            <p>Once you have created the access token, copy the value here</p>
                            {{else}}
                            <p>Unfortunately no documentation how to create a notification token yet</p>
                            {{end}}
                            <p><strong>The notification token is needed to report the build status back to your git repository.</strong></p>
                        </details>
                        <input type="text" name="notification_token" id="notification_token" value="" placeholder="***" class="form-control">
                        <small id="notificationTokenHelp" class="form-text text-muted">Current value is not echoed, leave it empty to keep it unchanged.</small>
                    </div>
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="trusted_user">Default trusted users ({{.RepoProvider}} usernames):</label></summary>
                            <p>Users who create a fork of your repository and then create a PR in your repository towards a CI enabled branch must be explicitly trusted. A PR that is not from a trusted user can be manually triggered by adding the comment <code>cscs-ci run</code> to the PR.</p>
                        </details>
                        <input type="text" name="trusted_user" id="trusted_user" value="{{.TrustedUser}}" class="form-control">
                        <small id="TrustedUserHelp" class="form-text text-muted">Comma-separated list of trusted users (applies to all pipelines, unless explicitly set to a different value in the pipeline config)</small>
                    </div>
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="ci_branches">Default CI enabled branches:</label></summary>
                            <p>If this list is empty, then CI will never trigger automatically on a push or pull request event. Wildcards are allowed (<code>*</code>=matches any number of characters, <code>?</code>=matches one or zero characters, <code>.</code>=matches exactly one character)</p>
                        </details>
                        <input type="text" name="ci_branches" id="ci_branches" value="{{.CIBranches}}" class="form-control">
                        <small id="ciBranchesHelp" class="form-text text-muted">Comma-separated list of branch names for which CI will run on each push event (applies to all pipelines, unless explicitly set to a different value in the pipeline config)</small>
                    </div>
                    <div class="form-group py-2">
                        <div>Variables (apply to all pipelines):</div>
                        <table class="table table-striped table-sm variables-table">
                            <thead>
                                <tr>
                                    <th>Key</th>
                                    <th>Value</th>
                                    <th class="text-center">Secret</th>
                                </tr>
                            </thead>
                            <tbody>
                                {{ range $var_idx, $var := .Variables }}
                                <tr>
                                    <td><input type="text" name="global_var_key_{{ $var_idx }}" value="{{ $var.Key }}" class="form-control-plaintext" readonly></td>
                                    <td><input type="text" name="global_var_value_{{ $var_idx }}" value="{{if $var.Secret}}●●●{{else}}{{$var.Value}}{{end}}" class="form-control-plaintext" readonly></td>
                                    <td class="text-center align-middle"><input type="checkbox" name="global_var_secret_{{ $var_idx }}" class="form-check-input" value="true" {{if $var.Secret}}checked{{end}} disabled></input></td>
                                    <td><button type="button" class="btn btn-danger delete-var"><svg class="bi"><use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#x-circle" /></svg><input type="hidden" name="global_var_status_{{ $var_idx }}" value=""></input></button></td>
                                </tr>
                                {{end}}
                                <tr>
                                    <td><input type="text" name="global_var_key_new" class="form-control" pattern="[A-Za-z0-9_]*" title="Alphanumeric and underscore"></input></td>
                                    <td><input type="text" name="global_var_value_new" class="form-control"></input></td>
                                    <td class="text-center align-middle"><input type="checkbox" name="global_var_secret_new" class="form-check-input" value="true" checked></input></td>
                                    <td><input type="hidden" name="global_var_status_new" value="new"></input></td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
        {{range .Pipelines}}
        <div class="accordion-item">
            <h2 class="accordion-header" id="headerPipeline{{.ID}}">
                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#collapsePipeline{{.ID}}" aria-expanded="false" aria-controls="collapsePipeline{{.ID}}">
                    <strong>Pipeline {{.Name}}</strong>
                </button>
            </h2>
            <div id="collapsePipeline{{.ID}}" class="accordion-collapse collapse" aria-labelledby="headerPipeline{{.ID}}" data-bs-parent="#accordionConfigs">
                <div class="accordion-body">
                    <div class="form-group py-2">
                        <label for="{{.ID}}_name">Pipeline name:</label>
                        <input type="text" name="{{.ID}}_name" id="{{.ID}}_name" value="{{.Name}}" pattern="[A-Za-z0-9\-]+" class="form-control">
                        <small class="form-text text-muted">Keep it short (e.g. P100, A100, GPU...). It will be used as name in the status notifications (alphanumeric characters or dash allowed, no whitespace)</small>
                    </div>
                    <div class="form-group py-2">
                        <label for="{{.ID}}_entrypoint">Pipeline YML-entrypoint:</label>
                        <input type="text" name="{{.ID}}_entrypoint" id="{{.ID}}_entrypoint" value="{{.CIEntrypoint}}" class="form-control">
                        <small class="form-text text-muted">Relative path to yml file in the repository</small>
                    </div>
                    <div class="form-group py-2">
                        <label for="{{.ID}}_trusted_user">Trusted users:</label>
                        <input type="text" name="{{.ID}}_trusted_user" id="{{.ID}}_trusted_user" value="{{.TrustedUser}}" class="form-control">
                        <small class="form-text text-muted">Comma-separated list of trusted users (overrides default config if not empty)</small>
                    </div>
                    <div class="form-group py-2">
                        <label for="{{.ID}}_ci_branches">CI enabled branches:</label>
                        <input type="text" name="{{.ID}}_ci_branches" id="{{.ID}}_ci_branches" value="{{.CIBranches}}" class="form-control">
                        <small class="form-text text-muted">Comma-separated list of branch names for which CI will run on each push event (overrides default config if not empty)</small>
                    </div>
                    {{$pipeline_id := .ID}}
                    {{range .Schedule}}
                    <div class="form-group py-2">
                        <details>
                            <summary><label for="{{$pipeline_id}}_schedule_{{.ScheduleID}}">Cron schedule:</label></summary>
                            <p>Use cron syntax followed by branch name <code>MINUTE HOUR DAY_OF_MONTH MONTH DAY_OF_WEEK BRANCH_NAME</code>, minimum interval is hourly, i.e. the first entry must be an integer value. E.g. daily at 21:15 would be <code>15 21 * * * main</code>, midnight on the weekend would be <code>0 0 * * 0,6 main</code>, every 12 hours would be <code>0 */12 * * * main</code>. Applicable timezone is Zurich time, i.e. CET/CEST.</p>
                            <p>Variables can be injected with the default syntax. <code>15 21 * * * main;MY_VAR=value;CRON_RUN=true</code></p>
                        </details>
                        <input type="text" name="{{$pipeline_id}}_schedule_{{.ScheduleID}}" id="{{$pipeline_id}}_schedule_{{.ScheduleID}}" value="{{.CronSchedule}}" pattern="(|[0-9]+ ([0-9,*\/\-]+ ){4}.+)" class="form-control">
                        <small class="form-text text-muted">Example: Daily branch main at 21:15 with additional variables CRON_RUN=true and OTHER_VARIABLE=42 - <code>15 21 * * * main;CRON_RUN=true;OTHER_VARIABLE=42</code></small>
                    </div>
                    {{end}}
                    <div class="form-check py-2">
                        <label class="form-check-label" for="{{.ID}}_trigger_pr">
                            <input type="checkbox" class="form-check-input" value="true" name="{{.ID}}_trigger_pr" id="{{.ID}}_trigger_pr" {{if .TriggerPR}} checked{{end}}> Trigger PR's targeting CI enabled branches automatically
                        </label>
                    </div>
                    <div class="form-group py-2">
                        <div>Variables (overwrites global variables on same key):</div>
                        <table class="table table-striped table-sm variables-table">
                            <thead>
                                <tr>
                                    <th>Key</th>
                                    <th>Value</th>
                                    <th class="text-center">Secret</th>
                                </tr>
                            </thead>
                            <tbody>
                                {{ range $var_idx, $var := .Variables }}
                                <tr>
                                    <td><input type="text" name="{{$pipeline_id}}_var_key_{{ $var_idx }}" value="{{ $var.Key }}" class="form-control-plaintext" readonly></td>
                                    <td><input type="text" name="{{$pipeline_id}}_var_value_{{ $var_idx }}" value="{{if $var.Secret}}●●●{{else}}{{$var.Value}}{{end}}" class="form-control-plaintext" readonly></td>
                                    <td class="text-center align-middle"><input type="checkbox" name="{{$pipeline_id}}_var_secret_{{ $var_idx }}" class="form-check-input" value="true" {{if $var.Secret}}checked{{end}} disabled></input></td>
                                    <td><button type="button" class="btn btn-danger delete-var"><svg class="bi"><use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#x-circle" /></svg><input type="hidden" name="{{$pipeline_id}}_var_status_{{ $var_idx }}" value=""></input></button></td>
                                </tr>
                                {{end}}
                                <tr>
                                    <td><input type="text" name="{{$pipeline_id}}_var_key_new" class="form-control" pattern="[A-Za-z0-9_]*" title="Alphanumeric and underscore"></input></td>
                                    <td><input type="text" name="{{$pipeline_id}}_var_value_new" class="form-control"></input></td>
                                    <td class="text-center align-middle"><input type="checkbox" name="{{$pipeline_id}}_var_secret_new" class="form-check-input" value="true" checked></input></td>
                                    <td><input type="hidden" name="{{$pipeline_id}}_var_status_new" value="new"></input></td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    {{if len $.Pipelines | le 2}}
                    <button class="btn btn-danger" type="submit" formaction="?repo={{$repo_id}}&action=delete&pipeline_id={{.ID}}">
                        <svg class="bi">
                            <use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#x-circle" />
                        </svg>
                        Delete pipeline {{.Name}}
                    </button>
                    {{end}}
                </div>
            </div>
        </div>
        {{end}}
    </div>
    <button type="submit" id="save_button" class="btn btn-primary">Save changes</button>
    <button type="submit" class="btn btn-secondary" formaction="?repo={{$repo_id}}&action=create">Add new pipeline</button>
</form>

<a href="/{{$p}}/overview" style="position: absolute; right: 10px; top: 10px">CI overview</a>

<script>
    let form_changed = false;
    let startup_function_executed = false;
    let startup_function = (event) => {
        if (startup_function_executed || document.visibilityState == "hidden") return
        startup_function_executed = true;
        setTimeout(() => {
            if ({{.SelectedPipeline}} != "") {
                bootstrap.Collapse.getOrCreateInstance(document.getElementById("collapsePipeline{{.SelectedPipeline}}")).show();
            } else {
                bootstrap.Collapse.getOrCreateInstance(document.getElementById("collapseGlobal")).show();
            }
            document.getElementById("webhook_setup_details_button").click()
        }, 300);
    }

    // either the tab was opened in the background and we receive a focus event or it is opened in the same tab,
    // then we receive a readystatechange event.
    document.addEventListener('visibilitychange', startup_function, {once: true});
    window.addEventListener('load', startup_function, {once: true});

    // uncollapse the accordion with an invalid field when submitting
    let oninvalid_cb = (event) => {
        invalidAccordion = document.querySelector(".accordion-collapse .form-control:invalid"); // document.querySelector(".accordion-collapse:has(.form-control:invalid)"); does not work with Firefox
        while (!invalidAccordion.classList.contains("accordion-collapse")) invalidAccordion = invalidAccordion.parentElement;
        if (invalidAccordion) {
            bootstrap.Collapse.getOrCreateInstance(invalidAccordion).show();
        }
    };

    document.getElementById("setup_form").addEventListener('submit', (event) => {
        if (form_changed == false) return true;
        if (event.submitter == document.getElementById("save_button")) return true;
        if (!confirm('All changes will also be saved. Continue?')) {
            event.preventDefault();
            return false;
        }
    });

    // react to input change events and send new values to server
    let onchange_cb = (event) => {
        form_changed = true;
//        let input = event.target
//        if (!input.validity.valid) return;
//        let pipeline_id = "global";
//        let field_name = input.name;
//        let new_value = input.value;
//        if (/^[0-9]/.test(field_name)) {
//            arr = input.name.split('_');
//            pipeline_id = arr.shift();
//            field_name = arr.join('_');
//        }
//        if (input.type == "checkbox") new_value = input.checked ? "true" : "false";
//        fetch(window.location.pathname, {
//            method: 'POST',
//            body: JSON.stringify({
//                "pipeline_id": pipeline_id,
//                "field_name": field_name,
//                "new_value": new_value
//            })
//        }).then((response) => response.text())
//          .then((text) => console.log(text));
    };

    let test_notification_token_for_input = (input) => {
        let new_value = input.value == "" ? "__dbvalue" : input.value;
        let searchparams = new URLSearchParams(window.location.search)
        searchparams.append("test_notification_token", new_value)
        fetch(`${window.location.pathname}?${searchparams.toString()}`)
            .then((response) => response.text())
            .then((text) => {
                if (text == "ok") { input.setCustomValidity(""); }
                else { input.setCustomValidity(text); }
            });
    }
    let test_notification_token = (event) => {
        test_notification_token_for_input(event.target)
    }


    for (let i of document.getElementsByTagName('input')) {
        i.addEventListener('invalid', oninvalid_cb);
        i.addEventListener('change', onchange_cb);
    }
    document.getElementById("notification_token").addEventListener("change", test_notification_token);
    test_notification_token_for_input(document.getElementById("notification_token"))

    for (let i of document.querySelectorAll('.variables-table tbody input[name$="_new"]')) {
        i.addEventListener('change', (event) => {
            for (let i of event.target.closest('tr').querySelectorAll('input[type="text"]')) {
                if (i.value == "") return;
            }
            // all values are non-empty --> add a new row
            cloned = event.target.closest('tr').cloneNode(true);
            for (let i of cloned.querySelectorAll('input')) {
                i["name"] = i["name"].replace("_new", `_${event.target.closest('tbody').children.length-1}`);
            }
            for (let i of event.target.closest('tr').querySelectorAll('input[type="text"]')) {
                i.value = ""
            }
            event.target.closest('tbody').insertBefore(cloned, event.target.closest('tr'));
        });
    }

    for (let i of document.querySelectorAll('.variables-table button.delete-var')) {
        i.addEventListener('click', (event) => {
            event.target.closest('button').querySelector('input').value = "deleted";
            event.target.closest('tr').classList.add('hidden');
        });
    }
</script>
<style>
  .variables-table tr.hidden {
      display: none;
  }
  .variables-table th {
      font-weight: normal;
  }
</style>
{{end}}

{{- template "base" . -}}
